no ethernet after suspend with forcedeth driver

Bug #288281 reported by Koen Mercken
76
This bug affects 9 people
Affects Status Importance Assigned to Milestone
Linux
Fix Released
High
linux (Ubuntu)
Medium
Andy Whitcroft
Intrepid
Medium
Andy Whitcroft

Bug Description

Binary package hint: network-manager

Network-manager can't connect eth0 after suspend on Ubuntu 8.10 frozen (64 bit).
version: 0.7~~svn20081018t105859-0ubuntu1

I am not shure its a network-manager problem because i can't connect mannually either.

I have tried this in console:

koen@ubuntu64:~$ sudo /etc/init.d/networking restart
 * Reconfiguring network interfaces...
Ignoring unknown interface eth0=eth0.

info about hardware:

ifconfig
eth0 Link encap:Ethernet HWaddr 00:1a:4d:70:ac:df
          inet6 addr: fe80::21a:4dff:fe70:acdf/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1
          RX packets:11476 errors:0 dropped:0 overruns:0 frame:0
          TX packets:8469 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:14170701 (14.1 MB) TX bytes:1230020 (1.2 MB)
          Interrupt:254 Base address:0xc000

lo Link encap:Local Loopback
          inet addr:127.0.0.1 Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING MTU:16436 Metric:1
          RX packets:1912 errors:0 dropped:0 overruns:0 frame:0
          TX packets:1912 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:157810 (157.8 KB) TX bytes:157810 (157.8 KB)

hwinfo --network

24: None 00.0: 10701 Ethernet
  [Created at net.124]
  Unique ID: usDW.ndpeucax6V1
  Parent ID: rBUF.Co2JF_zcRV2
  SysFS ID: /class/net/eth0
  SysFS Device Link: /devices/pci0000:00/0000:00:07.0
  Hardware Class: network interface
  Model: "Ethernet network interface"
  Driver: "forcedeth"
  Driver Modules: "forcedeth"
  Device File: eth0
  HW Address: 00:1a:4d:70:ac:df
  Link detected: yes
  Config Status: cfg=new, avail=yes, need=no, active=unknown
  Attached to: #9 (Ethernet controller)

===

SRU Justification

Justification: NVIDIA nForce wireless cards are lost after a suspend/resume cycle

Impact: wireless networking is lost after a suspend/resume cycle requiring a reboot

Fix Description: fixes to the reset processing following resume

Patch: http://kernel.ubuntu.com/git?p=ubuntu/ubuntu-intrepid.git;a=commit;h=ed9b2cfb2c0587aad0554996179c1b954471d7e6

Risks: this is a device specific change which is only applied on resume, where these devices already do not work. The change has also already been accepted upstream into the net-next tree.

TEST CASE: see bug

Related branches

Revision history for this message
Tero Konnola (weetabix) wrote :

I have the same problem (Intrepid Ibex, all updates, 32-bit).
Only difference is, that "/etc/init.d/network restart" gives "OK" as response.
I don't know if it should be there, but :
"cat /var/run/network/ifstate" it finds only lo=lo
When working there is also "eth0=eth0" -line
"ifup eth0" gives "unknown interface error eth0=eth0"

Revision history for this message
Jurgis Pralgauskis (jurgis-pralgauskis) wrote :

same situation for me Asus laptop z99H series
Intrepid RC
(I remember something very similar with gutsy beta)

Revision history for this message
Fumihito YOSHIDA (hito) wrote :

Hi Koen,

I guess this is same pattern ath_pci's problem, and this is not Network Managers bug.
https://wiki.ubuntu.com/IntrepidReleaseNotes/#Wireless%20doesn%27t%20work%20after%20suspend%20with%20ath_pci%20driver

Please test below,

/etc/pm/config.d/local:
SUSPEND_MODULES="forcedeth"

If it fixed the problem, please chenge this bugs"Affects", to "linux (Ubuntu)".

Revision history for this message
Alexander Sack (asac) wrote :

reproduce, then attach _complete_ syslog please.

Changed in network-manager:
status: New → Incomplete
Revision history for this message
Koen Mercken (koen-mercken) wrote :

Thanks Fumihoto, you were absolutely right. Adding SUSPEND_MODULES="forcedeth" fixed the problem.

Alexander: I will remove SUSPEND_MODULES="forcedeth" again and attach the log.

Revision history for this message
Koen Mercken (koen-mercken) wrote :
Revision history for this message
Alexander Sack (asac) wrote :

fix is to make forcedeth a suspend module.

Revision history for this message
James (james-ellis-gmail) wrote :

same issue here using 8.10/Kubuntu

On resume from suspend, no network devices are present. e.g running ifconfig shows no device.

Running "sudo /etc/init.d/networking restart" does not bring the device back, I have to killall NetworkManager then start NetworkManager again. The device then appears in ifconfig and knetworkmanager reconnects after a pause.

Doing:
/etc/pm/config.d/local:
SUSPEND_MODULES="forcedeth"

Makes the network come back on resume, although I'm not using the forcedeth driver:

46: None 00.0: 10701 Ethernet
  [Created at net.124]
  Unique ID: usDW.ndpeucax6V1
  Parent ID: rBUF.rpgJzxSJjg5
  SysFS ID: /class/net/eth0
  SysFS Device Link: /devices/pci0000:00/0000:00:1c.5/0000:09:00.0
  Hardware Class: network interface
  Model: "Ethernet network interface"
  Driver: "tg3"
  Driver Modules: "tg3"
  Device File: eth0
  HW Address: 00:1d:09:59:8b:d7
  Link detected: yes
  Config Status: cfg=new, avail=yes, need=no, active=unknown
  Attached to: #6 (Ethernet controller)

Revision history for this message
David Tombs (dgtombs) wrote :

I have a slightly different situation in that I must do the SUSPEND_MODULES="forcedeth" fix as well as an ifdown/ifup to get my network back.

After suspend, ethtool says that a link is detected, but the interface is not listed in ifconfig. ifup eth2 tells me:

ifup: interface eth2 already configured

After an ifdown eth2 and ifup eth2, the interface appears in ifconfig and I the ethernet works again. Without the SUSPEND_MODULES configuration, I must reload forcedeth module to get networking back.

Does everybody else have this same behavior? Or is this two different bugs? Let me know if you need any more information.

Revision history for this message
Randall Smith (randall-tnr) wrote :

I have the same problem (Intrepid Ibex, 64-bit). I used the workaround:

/etc/pm/config.d/local:
SUSPEND_MODULES="forcedeth"

which works, but then wake-on-lan doesn't work anymore.

Revision history for this message
Michael Backhaus (solidether) wrote :

Same problem here (Intrepid, 32-Bit): eth0 not usable after suspend.

The above fix solved the problem for me. Thx!

Revision history for this message
David Tombs (dgtombs) wrote :

This is more a note to myself than anything else, but feel free to investigate more if you care to do so. I'm a little scared to try compiling my own kernel.

I think this problem might have cropped up in kernel commit 25d90810ff49d2a63475776f24c74c6bb49b045f where suspend/resume behavior was changed.

Revision history for this message
Daniel Hahler (blueyed) wrote :

And there appears to be a patch at: https://kerneltrap.org/mailarchive/linux-kernel/2008/8/5/2827954

I'm linking a kernel.org bug that appears to address this issue.

Changed in linux:
status: Unknown → Confirmed
Revision history for this message
David Tombs (dgtombs) wrote :

Later in the post it says that the patch did not work properly, but I will try it out when I get the chance.

Andy Whitcroft (apw)
Changed in linux:
assignee: nobody → apw
status: Triaged → In Progress
Revision history for this message
Andy Whitcroft (apw) wrote :

Ok, as @David indicates the patch may or may not be sufficient to solve this issue. I have queried upstream in the linked bug, but in the interim I have taken the patch and built some test kernels with it applied. If any of you could test that kernel and report back here that would be most helpful. Kernels can be found at the URL below:

    URL

It would also be useful if you could test the latest Jaunty kernel (which should install just fine on an Intrepid system), and also report back here.

In both cases remember to remove any work arounds you might have in place before testing. Thanks in advance.

Revision history for this message
Andy Whitcroft (apw) wrote :
Changed in linux:
status: In Progress → Incomplete
Revision history for this message
David Tombs (dgtombs) wrote :

Thanks for uploading those debs, Andy. I was being too lazy to build, so they got me to actually test the thing. :)

Unfortunately, they seem to have no effect, removing the SUSPEND_MODULES workaround results in the same dead ethernet as before. What's more, `modprobe -r forcedeth` after resume results in kernel freeze, so I think forcedeth is left in an inconsistent state.

I don't have any more time to work on this tonight, but when I get a chance I will try playing around with some more patching. Let me know if there's anything else you'd like me to test.

Revision history for this message
David Tombs (dgtombs) wrote :

It appears that a patch has been submitted to the referenced kernel bug report.

Changed in linux:
status: Incomplete → Confirmed
Changed in linux:
status: Confirmed → Fix Released
Andy Whitcroft (apw)
Changed in linux:
status: Confirmed → In Progress
Stefan Bader (smb)
Changed in linux:
assignee: nobody → apw
importance: Undecided → Medium
status: New → In Progress
Revision history for this message
Andy Whitcroft (apw) wrote :

@David -- yes there seems to have been some pretty good feedback on that patch. I have sucked it down and applied it to the latest Intrepid kernel. If you could test those and report back here that would be helpful. The kernels can be found at the URL below (replacing the old kernels):

    http://people.ubuntu.com/~apw/lp288281-intrepid/

Changed in linux:
status: In Progress → Incomplete
Revision history for this message
Jochen Schneider (panama-joe) wrote :

The patch works perfectly for my system! (Asus M2N-SLI Deluxe motherboard)

Revision history for this message
Andy Whitcroft (apw) wrote :

Mailed the upstream source of the patch to find out whether it is being mainlined etc.

Revision history for this message
David Tombs (dgtombs) wrote :

Worked like a charm for me, too.

Revision history for this message
Jonathan Rogers (jonner) wrote :

I'm using forcedeth (for the onboard Nvidia MCP55 ethernet of a Gigabyte GA-M57SLI-S4) and with the standard kernel, the ethernet interface would never communicate after resuming from suspend. Using Andy's kernel build, it does work. In both cases, I get a non-fatal traceback in the kernel log, but it's unclear which, if any driver that's associated with.

Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.28-10.32

---------------
linux (2.6.28-10.32) jaunty; urgency=low

  [ Amit Kucheria ]

  * Delete prepare-ppa-source script

  [ Andy Isaacson ]

  * SAUCE: FSAM7400: select CHECK_SIGNATURE
  * SAUCE: LIRC_PVR150: depends on VIDEO_IVTV
    - LP: #341477

  [ Ayaz Abdulla ]

  * SAUCE: forcedeth: msi interrupt fix
    - LP: #288281

  [ Brad Figg ]

  * Updating armel configs to remove PREEMPT

  [ Catalin Marinas ]

  * Fix the VFP handling on the Feroceon CPU

  [ Huaxu Wan ]

  * SAUCE: (drop after 2.6.28) [Jaunty] iwlagn: fix iwlagn DMA mapping
    direction

  [ Ike Panhc ]

  * squashfs: correct misspelling
    - LP: #322306

  [ Theodore Ts'o ]

  * SAUCE: (drop after 2.6.28) ext4: add EXT4_IOC_ALLOC_DA_BLKS ioctl
  * SAUCE: (drop after 2.6.28) ext4: Automatically allocate delay allocated
    blocks on close
  * SAUCE: (drop after 2.6.28) ext4: Automatically allocate delay allocated
    blocks on rename
    - LP: #317781

  [ Tyler Hicks ]

  * SAUCE: (drop after 2.6.28) eCryptfs: Don't encrypt file key with
    filename key
    - LP: #342128

  [ Upstream Kernel Changes ]

  * ALS: hda - Add support of iMac 24 Aluminium
  * USB: fix broken OTG makefile reference
  * ALSA: hda - add another MacBook Pro 3,1 SSID
  * ALSA: hda - Add model entry for HP dv4
  * x86-64: fix int $0x80 -ENOSYS return
    - LP: #339743

 -- Tim Gardner <email address hidden> Thu, 12 Mar 2009 19:16:07 -0600

Changed in linux:
status: In Progress → Fix Released
Andy Whitcroft (apw)
Changed in linux:
status: Incomplete → In Progress
Andy Whitcroft (apw)
description: updated
Changed in linux:
status: In Progress → Fix Committed
Changed in linux:
status: Fix Released → Confirmed
Changed in linux:
status: Confirmed → Fix Released
Revision history for this message
sree kasturi (sree-kasturi) wrote :

problem persists in 2.6.28-11 (Ubuntu Jaunty). need to upgrade kernel to 2.6.30-rc2.

fix verified in 2.6.30-2.

Revision history for this message
David Tombs (dgtombs) wrote :

Actually, I can confirm fixed in Jaunty. You must be experiencing a different bug.

Revision history for this message
Martin Pitt (pitti) wrote :

Accepted linux into intrepid-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

tags: added: verification-needed
Steve Beattie (sbeattie)
tags: added: hw-specific
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.27-14.41

---------------
linux (2.6.27-14.41) intrepid-proposed; urgency=low

  [ Stefan Bader ]

  * Revert "SAUCE: input: Blacklist digitizers from joydev.c"
    - LP: #300143

linux (2.6.27-14.40) intrepid-proposed; urgency=low

  [ Amit Kucheria ]

  * Disable DEVKMEM for all archs on Intrepid
    - LP: #354221
  * SAUCE: Quirk for BT USB device on MacbookPro to be reset before use
    - LP: #332443

  [ Andy Isaacson ]

  * LIRC_PVR150: depends on VIDEO_IVTV
    - LP: #341477
  * SAUCE: FSAM7400: select CHECK_SIGNATURE
    - LP: #341712

  [ Andy Whitcroft ]

  * SAUCE: hotkey quirks for various Zepto Znote and Fujitsu Amilo laptops
    - LP: #330259
  * SAUCE: unusual devs: add an entry for the ScanLogic SL11R-IDE 0.78
    - LP: #336189

  [ Anton Veretenenko ]

  * SAUCE: sony-laptop: add support for Sony Vaio FW series function/media
    keys
    - LP: #307592

  [ Ayaz Abdulla ]

  * SAUCE: forcedeth: msi interrupt fix
    - LP: #288281

  [ Chuck Short ]

  * SAUCE: [USB] Unusual Device support for Gold MP3 Player Energy
    - LP: #125250

  [ Ike Panhc ]

  * squashfs: correct misspelling
    - LP: #322306
  * SAUCE: Fixing symbol name in HECI module
    - LP: #336549
  * Copy header files for various kernel media driver
    - LP: #322732

  [ Stefan Bader ]

  * SAUCE: vgacon: Return the upper half of 512 character fonts
    - LP: #355057
  * SAUCE: input: Blacklist digitizers from joydev.c
    - LP: #300143

  [ Upstream Kernel Changes ]

  * libata: make sure port is thawed when skipping resets
    - LP: #269652
  * x86-64: fix int $0x80 -ENOSYS return
    - LP: #339743
  * rt2x00: Fix race conditions in flag handling
    - LP: #258985
  * USB: cdc-acm: Add another conexant modem to the quirks
    - LP: #323829
  * Bluetooth: Add fine grained mem_flags usage to btusb driver
    - LP: #268502
  * Bluetooth: Handle bulk URBs in btusb driver from notify callback
    - LP: #268502
  * Bluetooth: Submit bulk URBs along with interrupt URBs
    - LP: #268502
  * hwmon: (abituguru3) Match partial DMI board name strings
    - LP: #298798
  * x86: mtrr: don't modify RdDram/WrDram bits of fixed MTRRs
    - LP: #292619
  * sis190: add identifier for Atheros AR8021 PHY
    - LP: #247889
  * ath9k: implement IO serialization
    - LP: #373034
  * ath9k: AR9280 PCI devices must serialize IO as well
    - LP: #373034
  * acer-wmi: fix regression in backlight detection
    - LP: #333386

 -- Stefan Bader <email address hidden> Wed, 26 Aug 2009 11:48:11 +0200

Changed in linux (Ubuntu Intrepid):
status: Fix Committed → Fix Released
Revision history for this message
Stewart Midwinter (midtoad) wrote :

this bug appears to be still around in Karmic Koala. I experience the problem of having no wireless networking device available after resuming from a suspend in 9.10, with kernel 2.6.31-14-generic running on an EeePC 900HA.

adding "forcedeth" has no effect. Killing NetworkManager, then restarting it, has no effect. Starting and stopping networking has no effect. ifdown/ifup has no effect. I'm stuck with "no network devices available".

Revision history for this message
eugenio (eugenio-lacava) wrote :

i think i have the same problem but with the wired interface and i'm running ubuntu 9.10 karmic. I tried everyone of the solution proposed except for the kernel patches wich are not specific for my hw. please fix this soon i often use suspend and is very annoying to have to reboot eachtime to be able to use ethernet. My ethernet controller is 02:00.0 Ethernet controller: Marvell Technology Group Ltd. 88E8053 PCI-E Gigabit Ethernet Controller (rev 15)

Revision history for this message
Jonathan Rogers (jonner) wrote :

Stewart Midwinter and eugenio , please read the description of this bug carefully. It is specific to the Linux driver called "forcedeth" which is exclusively for Nvidia wired interfaces. It has nothing to do with wireless networking or any non-Nvidia hardware.

If you're experiencing similar symptoms with different hardware, try to find a bug report more accurately describing your problem or file a new one.

Revision history for this message
Dr. Xylem Galadhon (xylemtg) wrote :

I wanted to respond to the very first post (bug description, *before* post #1):

So i *don't* use Ubuntu, but am on a Fedora Core 10 system, but just doing as suggested in the first post:

"sudo /etc/init.d/network restart"

(which is what the command is on my system, not "networking"), works totally fine. this made me very happy, and i'm so glad i don't now have to reboot, everytime i want to bring up my connection again.

This is the kind of time i *love* the community of Linux people helping each other out there -- when it's not a hard fix, and works right quickly!!

Now, if i could only get my keybd and mouse to work after a suspend (none of the simplest stuff i tried yet worked), and sound, and webcam, and touchscreen support.... it'd be miraculous. but, alas, i am not a hardcore Linux-er, and will still have to use the "Evil OS" to get these things working for now.. :-(

But, for now, for this -- thx so much, folks. :->

Changed in linux:
importance: Unknown → High
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.